/** Fichier station.c **/

/******************************************************************/
/**                        Serveur IMAP2                         **/
/******************************************************************/

/** Fichiers d'inclusion **/
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <poll.h>
#include "station.h"
#include "libcom.h"
#include "libthrd.h"

/*************************************Verif LOGIN*******************************************/

int VerifLogin(char *arg1, char *arg2)
{
	int login_ok;
	FILE *monFichier = NULL;
	monFichier = fopen("LOGIN.txt", "r");
	char login[MAX_LIGNE] = "";
	char buffer_arg1[MAX_LIGNE] = "";
	strcpy(buffer_arg1, arg1);
	if (monFichier != NULL)
	{
		strcat(buffer_arg1, "\n");
		while (fgets(login, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
		{
			if (strcmp(buffer_arg1, login) == 0)
			{
				login_ok = 1;
			}
		}

		fclose(monFichier);
		return login_ok;
	}
	else
	{
		// On affiche un message d'erreur si on veut
		printf("Impossible d'ouvrir le fichier test.txt");
	}

	fclose(monFichier);

	return 0;
}
/*************************************Nombres de mail***************************************/

int Nombre_mail(char *user, char *arg1)
{
	struct dirent **namelist;
	int n, n_max;
	int iFile_txt = 0;
	char Chemin[MAX_LIGNE] = "";
	if ((strcmp(arg1, "INBOX") == 0) | (strcmp(arg1, "") == 0))
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX", user);
	}
	else
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/%s", user, arg1);
	}

	n = scandir(Chemin, &namelist, 0, alphasort);
	n_max = n;
	if (n < 0)
	{
		perror("scandir");
	}
	else
	{
		for (n = 0; n < n_max; n++)
		{
			if (strstr(namelist[n]->d_name, ".txt") != NULL)
			{ // On cherche si le fichier contient .txt
				iFile_txt++;
			}
			free(namelist[n]);
		}
		free(namelist);
	}
	return iFile_txt;
}

/************************************LECTURE FLAGS******************************************/

nombre_flags_t Lect_Flags(char *user, nombre_flags_t nb_flags, int nb_mail, int *tab_sup, int *tab_sup2, char *arg1)
{
	struct dirent **namelist;
	nb_flags.Recent = 0;
	nb_flags.Deleted = 0;
	char Chemin[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";
	int j = 0;
	int k = 0;
	int n, n_max, val1;
	char cVal[6];
	char Memo_mail_status[100][MAX_LIGNE];

	if ((strcmp(arg1, "INBOX") == 0) | (strcmp(arg1, "") == 0))
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX", user);
	}
	else
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/%s", user, arg1);
	}

	n = scandir(Chemin, &namelist, 0, alphasort);
	n_max = n;
	if (n < 0)
	{
		perror("scandir");
	}
	else
	{
		for (n = 2; n < n_max; n++)
		{
			if (strstr(namelist[n]->d_name, ".status") != NULL)
			{
				strcpy(Memo_mail_status[j], namelist[n]->d_name);
				j++;
				//printf("******1: %s \n",namelist[n]->d_name);
			}
			free(namelist[n]);
		}
		free(namelist);
		j = 0;
	}

	for (int i = 0; i < nb_mail + 1; i++) // on parcours tout les mails
	{
		FILE *monFichier = NULL;
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%s", user, Memo_mail_status[i]);

		monFichier = fopen(Chemin, "r");
		if (monFichier != NULL)
		{
			while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				if (strcmp(Flag_R, msg_recu) == 0)
				{
					nb_flags.Recent = nb_flags.Recent + 1;
					tab_sup[j] = i;
					j = j + 1;
				}
				if (strcmp(Flag_D, msg_recu) == 0)
				{
					nb_flags.Deleted = nb_flags.Deleted + 1;
					sprintf(cVal, "%c%c%c", Memo_mail_status[i][0], Memo_mail_status[i][1], Memo_mail_status[i][2]); //on recupere le numero de mail
					val1 = atoi(cVal);																				 //conversion en int
					tab_sup2[k] = val1;																				 //on le rajoute dans un tableau pour pouvoir faire un expunge
					k = k + 1;
				}
			}

			fclose(monFichier);
		}
		else
		{
			// On affiche un message d'erreur si on veut
			printf("Impossible d'ouvrir les mails de %s \n", user);
		}
	}
	memset(Memo_mail_status, 0, sizeof(Memo_mail_status));

	return nb_flags;
}
/************************************Supprimer Ligne******************************************/

int Sup_Ligne(char *user, char *Flag, int num_mail) //num status = numero du .status a supprimer le Flag
{
	char Chemin[MAX_LIGNE] = "";
	char Chemintemp[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";

	FILE *monFichier = NULL;
	FILE *monFichiertemp = NULL;

	sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, num_mail);
	sprintf(Chemintemp, "../Messages/Utilisateur/%s/INBOX/%dtemp.status", user, num_mail);

	printf("CHEMIN sup ligne : %s\n", Chemin);
	printf("CHEMIN sup ligne : %s\n", Chemintemp);

	monFichier = fopen(Chemin, "r+");

	monFichiertemp = fopen(Chemintemp, "w");

	if ((monFichier != NULL) | (monFichiertemp != NULL))
	{
		while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
		{
			if (strcmp(Flag, msg_recu) != 0)
			{
				fputs(msg_recu, monFichiertemp);
				printf("ok");
				//fwrite(msg_recu,1,sizeof(msg_recu),monFichiertemp);
				//fprintf(monFichiertemp,"%s",msg_recu);
			}
		}

		fclose(monFichier);
		fclose(monFichiertemp);
	}
	else
	{
		printf("Erreur ouverture fichier sup\n");
	}

	if (remove(Chemin) == 0)
	{
		printf("fichier supprimer\n");
	}

	else
	{
		printf("fichier Non supprimer\n");
	}
	rename(Chemintemp, Chemin);
	return 0;
}

/************************************Ajouter ligne******************************************/
void Ajt_Ligne(char *user, char *Flag, char *num_mail)
{
	char Chemin[MAX_LIGNE] = "";
	FILE *monFichier = NULL;
	sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%s.status", user, num_mail);
	printf("CHEMIN ajout ligne : %s\n", Chemin);

	monFichier = fopen(Chemin, "a+");

	if (monFichier != NULL)
	{
		fputs(Flag, monFichier);
		printf("ok ligne ajouté\n");
		fclose(monFichier);
	}
	else
	{
		printf("Erreur ouverture fichier AJOUTER\n");
	}
}
/************************************Fonction ENUM ******************************************/

int Enum_nb(char *arg1, int *tab_enum)
{
	int nb_enum;
	int i = 0;
	int j = 0;
	int val1 = 0;
	int val2 = 0;
	char cVal1[2];
	char cVal2[6];
	char cVal3[2];
	sprintf(cVal1, "%c", arg1[0]);
	sprintf(cVal3, "%c", arg1[1]);
	sprintf(cVal2, "%c%c%c", arg1[2], arg1[3], arg1[4]);

	val1 = atoi(cVal1);
	val2 = atoi(cVal2);
	nb_enum = val2; //nombre max de valeur

	if ((val1 < val2) && (strcmp(cVal3, ":") == 0))
	{
		for (i = val1; i < val2 + 1; i++)
		{
			tab_enum[j] = i;
			printf("i : %d \n", i);
			j = j + 1;
		}
		return nb_enum;
	}
	else
	{
		printf("erreur syntaxe");
	}
	return 0;
}
/************************************Fonction COPY ******************************************/

void fct_copy(char *user, char *arg2, int *tab_enum, int nb_enum)
{
	int i;
	char Chemin[MAX_LIGNE] = "";
	char Chemin_status[MAX_LIGNE] = "";
	char Chemin2_status[MAX_LIGNE] = "";
	char Chemin_txt[MAX_LIGNE] = "";
	char Chemin2_txt[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";

	FILE *monFichier_status = NULL;
	FILE *monFichier2_status = NULL;

	FILE *monFichier_txt = NULL;
	FILE *monFichier2_txt = NULL;
	sprintf(Chemin, "../Messages/Utilisateur/%s/%s/", user, arg2);

	struct stat st = {0};

	if (stat(Chemin2_status, &st) == -1)
	{
		mkdir(Chemin, 0777);
		printf("******* Chemin Répertoire crée************\n\n");
	}

	for (i = 0; i < nb_enum - 1; i++)
	{
		sprintf(Chemin_status, "../Messages/Utilisateur/%s/INBOX/%d.status", user, tab_enum[i]);
		//printf("*****CHEMINS STATUS : %s ******\n\n",Chemin_status);
		sprintf(Chemin2_status, "../Messages/Utilisateur/%s/%s/%d.status", user, arg2, tab_enum[i]);

		sprintf(Chemin_txt, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
		//printf("*****CHEMINS TXT : %s ******\n\n",Chemin_txt);
		sprintf(Chemin2_txt, "../Messages/Utilisateur/%s/%s/%d.txt", user, arg2, tab_enum[i]);
		monFichier_status = fopen(Chemin_status, "r+");
		monFichier2_status = fopen(Chemin2_status, "w+");

		monFichier_txt = fopen(Chemin_txt, "r+");
		monFichier2_txt = fopen(Chemin2_txt, "w+");

		//printf("*****%s\n",Chemin2_txt);

		if (monFichier_status != NULL)
		{
			while (fgets(msg_recu, MAX_LIGNE, monFichier_status) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				fputs(msg_recu, monFichier2_status);
				//printf("tout ok");
			}

			fclose(monFichier_status);
			fclose(monFichier2_status);
		}
		else
		{
			printf("FILE STATUS NOT CREATED/OPENED \n");
		}

		if (monFichier_txt != NULL)
		{
			while (fgets(msg_recu, MAX_LIGNE, monFichier_txt) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				fputs(msg_recu, monFichier2_txt);
			}

			fclose(monFichier_txt);
			fclose(monFichier2_txt);
		}

		else
		{
			printf("FILE TXT NOT CREATED/OPENED");
		}
	}
	//return 0;
}

/*************************************GESTION CLIENT ***************************************/

int gestionClientTCP(int s)
{
	nombre_flags_t nb_flags;
	char ligne[MAX_LIGNE];
	char tag[MAX_LIGNE], fct[MAX_LIGNE], arg1[MAX_LIGNE], arg2[MAX_LIGNE], arg3[MAX_LIGNE];
	char user[MAX_LIGNE] = "";
	int login_ok = 0;
	int tab_sup[MAX_LIGNE] = {0};
	int tab_sup2[MAX_LIGNE] = {0};
	int tab_enum[MAX_LIGNE] = {0};
	//int s=*(int *)arg;

	/* Obtient une structure de fichier */
	FILE *dialogue = fdopen(s, "a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if (dialogue == NULL)
	{
		perror("gestionClientTCP.fdopen");
		exit(EXIT_FAILURE);
	}

	fwrite(reponse_log0, 1, sizeof(reponse_log0), dialogue);

	while (fgets(ligne, MAX_LIGNE, dialogue) != NULL) //while(fgets(ligne,MAX_LIGNE,dialogue)) //while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL && strlen(ligne) < 3)
	{
		sscanf(ligne, "%s %s %s %s %s", tag, fct, arg1, arg2, arg3);

		printf(">tag: %s >fct: %s >arg1: %s >arg2: %s >arg3 : %s \n", tag, fct, arg1, arg2, arg3);
		printf(">ligne : %s", ligne);

		if (strcmp(fct, "LOGIN") == 0)
		{
			login_ok = Login(arg1, arg2, dialogue);
			strcpy(user, arg1);
		}

		if ((strcmp(fct, "LOGOUT") == 0) && login_ok == 1)
		{
			login_ok = Logout(dialogue);
		}

		if ((strcmp(fct, "NOOP") == 0) && login_ok == 1)
		{
			Noop(dialogue);
		}

		if ((strcmp(fct, "SELECT") == 0) && login_ok == 1)
		{
			Select(user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		if ((strcmp(fct, "CHECK") == 0) && login_ok == 1)
		{
			Check(user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		if ((strcmp(fct, "EXPUNGE") == 0) && login_ok == 1)
		{

			Expunge(user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		if ((strcmp(fct, "STORE") == 0) && login_ok == 1)
		{
			Store(user, arg1, arg2, arg3);
		}

		if (strcmp(fct, "COPY") == 0)
		{
			Copy(arg1, arg2, user, tab_enum);
		}
		if (strcmp(fct, "FETCH") == 0)
		{
			//appel fonction fetch
		}

		if (!(strcmp(fct, "") == 0) && !(strcmp(fct, "LOGIN") == 0) && login_ok == 0)
		{
			printf("\n **********tu n'est pas connecté***********\n");
		}

		strcpy(arg1, "");
		strcpy(arg2, "");
		strcpy(arg3, "");
	}

	/* Termine la connexion */
	fclose(dialogue);
	printf("client déconnecté\n");
	return 0;
}

int multi_gestionClientTCP(int s)
{
	//int dialogue= s;
	lanceThread(gestionClientTCP, (int)s, 0);
	return 0;
}

void serveur_TCP(void)
{
	int s = 0;

	/* Initialisation du serveur */
	s = initialisationServeurTCP(port, MAX_connexions);
	/* Lancement de la boucle d'ecoute */
	//boucleServeurTCP(s,gestionClientTCP);
	boucleServeurTCP(s, multi_gestionClientTCP);

	/* On termine la connexion */
	shutdown(s, SHUT_RDWR);
}

int main(int argc, char *argv[])
{
	serveur_TCP();
	return 0;
}

/*********************************************************************************************FONCTIONS*****************************************************************************************/

int Login(char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], FILE *dialogue)
{

	int login_ok;

	login_ok = VerifLogin(arg1, arg2);

	if ((login_ok == 1) && (strcmp(arg2, "") != 0))
	{
		fwrite(reponse_log1, 1, sizeof(reponse_log1), dialogue);
		return 1;
	}
	else if ((login_ok == 0))
	{
		fwrite(reponse_log2, 1, sizeof(reponse_log2), dialogue); // utilisateur inexistant
		return 0;
	}
	else
	{
		fwrite(reponse_log3, 1, sizeof(reponse_log3), dialogue); //mauvais mdp
		return 0;
	}
}

int Logout(FILE *dialogue)
{

	fwrite(reponse_log4, 1, sizeof(reponse_log4), dialogue);

	return 0;
}

void Noop(FILE *dialogue)
{

	printf("noop envoyé \n");
	fwrite(reponse_log5, 1, sizeof(reponse_log5), dialogue);
}

void Select(char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{

	printf("SELECT \n");
	int nb_mail = Nombre_mail(user, arg1);
	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";

	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
	}
	else
	{
		fwrite(reponse_log8, 1, sizeof(reponse_log8), dialogue);
	}
}

void Check(char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{

	printf("CHECK \n");
	int nb_mail = Nombre_mail(user, arg1);
	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";

	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
	}
	else
	{
		fwrite(reponse_log8, 1, sizeof(reponse_log8), dialogue);
	}
}

void Expunge(char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{

	int nb_mail = Nombre_mail(user, arg1);
	printf("EXPUNGE \n");

	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";
	char Chemin[MAX_LIGNE] = "";
	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);

		for (int i = 0; i < nb_flags.Deleted; i++)
		{
			printf("fichier contient : %d\n", tab_sup2[i]);
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, tab_sup2[i]);
			remove(Chemin);
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_sup2[i]);
			remove(Chemin);
		}
		nb_mail = Nombre_mail(user, arg1);
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
	}
	else
	{
		fwrite(reponse_log8, 1, sizeof(reponse_log8), dialogue);
	}
}

void Store(char user[MAX_LIGNE], char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], char arg3[MAX_LIGNE])
{

	char Flag[MAX_LIGNE] = "";
	char charToConvert[2]; //pour convertir un char en int
	int charConverted;	 //pour convertir un char en int

	if (strcmp(arg3, "\\Deleted") == 0)
	{
		strcpy(Flag, Flag_D);
	} // FLAG = DELETED
	else if (strcmp(arg3, "\\Seen") == 0)
	{
		strcpy(Flag, Flag_S);
	} // FLAG = SEEN
	else if (strcmp(arg3, "\\Recent") == 0)
	{
		strcpy(Flag, Flag_R);
	} // FLAG = RECENT
	else if (strcmp(arg3, "\\Answered") == 0)
	{
		strcpy(Flag, Flag_A);
	} // FLAG = ANSWERED
	else if (strcmp(arg3, "\\Flagged") == 0)
	{
		strcpy(Flag, Flag_F);
	} // FLAG = FLAGGED
	else
	{
		printf("error arg 3\n");
	}

	if (strcmp(arg2, "+Flags") == 0)
	{
		Ajt_Ligne(user, Flag, arg1);
	}
	else if (strcmp(arg2, "-Flags") == 0)
	{
		sprintf(charToConvert, "%s", arg1);
		charConverted = atoi(charToConvert); //permet de convertir un char en int pour le passé en parametre a la fct sup_ligne
		Sup_Ligne(user, Flag, charConverted);
	}
	else
	{
		printf("error arg 2\n");
	}
}

void Copy(char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], char user[MAX_LIGNE], int *tab_enum)
{
	int nb_enum = Enum_nb(arg1, tab_enum);

	for (int i = 0; i < nb_enum; i++)
	{
		printf(" **********%d***********\n", tab_enum[i]);
	}

	fct_copy(user, arg2, tab_enum, nb_enum);

	memset(tab_enum, 0, sizeof(tab_enum));
}

void Fetch()
{
}