/** fichier station.h **/
#include "libcom.h"

/***************************************************/
/* Structures necessaires pour la station IMAP2    */
/***************************************************/



/******* Constantes *******/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024


const int MAX_connexions = 6; //maximum 6 clients dans la file d'attente TCP

const char Flag_R[] = "\\RECENT\n";
const char Flag_S[] = "\\SEEN\n";
const char Flag_D[] = "\\DELETED\n";
const char Flag_A[] = "\\ANSWERED\n";
const char Flag_F[] = "\\FLAGGED\n";

const char reponse_log0[] = "OK IMAP2 Server Ready \n\r";
const char reponse_log1[] = "A001 OK User logged in \n";
const char reponse_log2[] = "LOGIN_ERROR\n";
const char reponse_log3[] = "FONCTION_ERROR\n";
const char reponse_log4[] = "OK Logout complete\n";
const char reponse_log5[] = "OK NOOP\n";
const char reponse_log8[] = "ERROR MAILBOX does not exist\n";

/** Structures **/
typedef struct
{
	int Recent;
	int Deleted;
} nombre_flags_t;




/** Variables publiques  **/
//int s=3;
char *port = "993"; // faire attention à ne pas choisir un port utilisé par le système

int adresse = 0;

/** Prototypes fonctions**/
//void analyseArguments(int argc,char *argv[]);
int VerifLogin(char *, char *);
int Nombre_mail(char *,char*);
nombre_flags_t Lect_Flags(char *, nombre_flags_t , int , int *, int *,char[]);
int Sup_Ligne(char *, char *, int );
void Ajt_Ligne(char *, char *, char *);
int Enum_nb(char *, int *);
void fct_copy(char *, char *, int *, int );
int gestionClientTCP(int s);
void serveur_TCP(void);
int multi_gestionClientTCP(int s);
int  Login  (char[],char[], FILE *);
int  Logout (FILE * );
void Noop (FILE * );
void Select (char [], nombre_flags_t ,int *, int *, FILE * ,char[]);
void Check (char [], nombre_flags_t ,int *, int *, FILE *,char[]);
void Expunge(char [], nombre_flags_t , int *, int *, FILE *,char[]);
void Store(char [], char [], char [], char []);
void Copy(char [], char [], char [],int*);